package dev.lowrespalmtree.comet

import android.os.Bundle
import android.util.Log
import android.view.MenuItem
import androidx.appcompat.app.ActionBarDrawerToggle
import androidx.appcompat.app.AppCompatActivity
import androidx.core.os.bundleOf
import androidx.navigation.fragment.NavHostFragment
import androidx.navigation.ui.setupActionBarWithNavController
import androidx.navigation.ui.setupWithNavController
import dev.lowrespalmtree.comet.databinding.ActivityMainBinding
import kotlinx.coroutines.ExperimentalCoroutinesApi


@ExperimentalCoroutinesApi
class MainActivity : AppCompatActivity() {
    private val binding by lazy { ActivityMainBinding.inflate(layoutInflater) }
    private val nhf by lazy { supportFragmentManager.findFragmentById(R.id.nav_host_fragment) as NavHostFragment }
    private val navController by lazy { nhf.navController }

    override fun onCreate(savedInstanceState: Bundle?) {
        Log.d(TAG, "onCreate")
        super.onCreate(savedInstanceState)
        setContentView(binding.root)
        setSupportActionBar(binding.toolbar)

        Database.init(applicationContext)  // TODO move to App Startup?

        val toggle = ActionBarDrawerToggle(
            this,
            binding.drawerLayout,
            binding.toolbar,
            R.string.navigation_drawer_open,
            R.string.navigation_drawer_close
        )
        binding.drawerLayout.addDrawerListener(toggle)
        toggle.syncState()
        setupActionBarWithNavController(navController, binding.drawerLayout)
        binding.drawerNavigation.setupWithNavController(nhf.navController)
    }

//    /** Navigate to the PageViewFragment; this will automatically use the home URL if any. */
//    fun goHome(@Suppress("unused_parameter") item: MenuItem) {
//        val bundle = bundleOf()
//        Preferences.getHomeUrl(this)?.let { bundle.putString("url", it) }
//    }

    companion object {
        private const val TAG = "MainActivity"
    }

}